# include <windows.h>
# include <sql.h>
# include <sqlext.h>
# include <stdio.h>
# include <stdlib.h>

SQLCHAR database[] = "tis";
SQLCHAR user[] = "tis";
SQLCHAR password[] = "tis";

# define CHECK(call) check(call, __FILE__, __LINE__)

// kontrola nvratov hodnoty
void check(SQLRETURN ret, char* file, int line)
{
    if( SQL_SUCCEEDED(ret) ) return;
    printf("Error (%s, %d): %d\n", file, line, ret);
    exit(0);
}

void main(int argc,char* argv[])
{
        // alokace zstupce sprvce ovlada
    SQLHENV henv1;
    CHECK(SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &henv1));

    // nastaven verze ODBC 3.0
    SQLSetEnvAttr(henv1, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) SQL_OV_ODBC3, 0);

    // alokace zstupce databzovho pipojen
    SQLHDBC hdbc1;
    CHECK(SQLAllocHandle(SQL_HANDLE_DBC, henv1, &hdbc1));

    // pipojen k databzi
    CHECK(SQLConnect(hdbc1, database, SQL_NTS, user, SQL_NTS, password, SQL_NTS));

    // alokace zstupce pkazu
    SQLHSTMT hstmt1;
    CHECK(SQLAllocHandle(SQL_HANDLE_STMT, hdbc1, &hstmt1));

    // proveden dotazu
    char psmt[512] = "SELECT id,nazev,osoby.prijmeni FROM katedry,osoba WHERE osoby.login=katedry.vedouci and id=";
    strncat( psmt, argv[1], sizeof(argv[1]));

    CHECK(SQLExecDirect(hstmt1, (SQLCHAR*)psmt, SQL_NTS));

    SQLCHAR      szName[51];
    SQLCHAR      szVedouci[51];
    SQLINTEGER   cb;
    SQLINTEGER   id;

    // navzn promnnch ve vsledku dotazu
    CHECK(SQLBindCol(hstmt1, 1, SQL_C_LONG, &id, 0, &cb));
    CHECK(SQLBindCol(hstmt1, 2, SQL_C_CHAR, szName, 50, &cb));
    CHECK(SQLBindCol(hstmt1, 3, SQL_C_CHAR, szVedouci, 50, &cb));

    // zpracovn vsledku dotazu
    SQLRETURN ret;
    while ( (ret = SQLFetch(hstmt1) ) != SQL_NO_DATA ) {
        printf("%d: %s : %s\n", id, szName,szVedouci);
    }

    // klid
    SQLFreeHandle(SQL_HANDLE_STMT, hstmt1);
    SQLDisconnect(hdbc1);
    SQLFreeHandle(SQL_HANDLE_DBC, hdbc1);
    SQLFreeHandle(SQL_HANDLE_ENV, henv1);
}
